commit 862f3b5f92558517a616e14fab0a83ad6fcc24ef
Author: freddy77 <freddy77>
Date:   Wed Feb 13 08:52:08 2008 +0000

    merged small memory issues, fix test64 test output

diff --git a/ChangeLog b/ChangeLog
index 393b4a0..bd126d0 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Wed Feb 13 09:50:35 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/apps/bsqlodbc.c: fix memory error
+	* src/tds/query.c: remove possible buffer underflow
+	* src/odbc/unittests/test64.c: truncate upper part for low
+
 Fri Feb 08 10:26:36 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/Makefile.am src/odbc/unittests/describecol.in:
 	* src/odbc/unittests/params.c src/odbc/unittests/putdata.c:
@@ -158,4 +163,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2487 2008/02/08 09:28:01 freddy77 Exp $
+$Id: ChangeLog,v 1.2488 2008/02/13 08:52:08 freddy77 Exp $
diff --git a/src/apps/bsqlodbc.c b/src/apps/bsqlodbc.c
index 1050550..89d9c19 100644
--- a/src/apps/bsqlodbc.c
+++ b/src/apps/bsqlodbc.c
@@ -50,7 +50,7 @@
 #include <sqlext.h>
 #include "replacements.h"
 
-static char software_version[] = "$Id: bsqlodbc.c,v 1.9 2007/11/26 06:25:57 freddy77 Exp $";
+static char software_version[] = "$Id: bsqlodbc.c,v 1.10 2008/02/13 08:52:09 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char * next_query(void);
@@ -339,6 +339,10 @@ main(int argc, char *argv[])
 		} 
 	}
 
+	SQLDisconnect(hDbc);
+	SQLFreeHandle(SQL_HANDLE_DBC, hDbc);
+	SQLFreeHandle(SQL_HANDLE_ENV, hEnv);
+
 	return 0;
 }
 
@@ -347,14 +351,15 @@ next_query()
 {
 	char query_line[4096];
 	static char *sql = NULL;
-	
+
 	if (feof(stdin))
 		return NULL;
-			
+
 	fprintf(options.verbose, "%s:%d: Query:\n", options.appname, __LINE__);
-	
+
 	free(sql);
-	
+	sql = NULL;
+
 	while (fgets(query_line, sizeof(query_line), stdin)) {
 		/* 'go' or 'GO' separates command batches */
 		char *p = query_line;
diff --git a/src/odbc/unittests/test64.c b/src/odbc/unittests/test64.c
index 8d0dd75..4078cd8 100644
--- a/src/odbc/unittests/test64.c
+++ b/src/odbc/unittests/test64.c
@@ -1,7 +1,7 @@
 /* test win64 consistency */
 #include "common.h"
 
-static char software_version[] = "$Id: test64.c,v 1.4 2008/01/29 14:30:49 freddy77 Exp $";
+static char software_version[] = "$Id: test64.c,v 1.5 2008/02/13 08:52:09 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 /*
@@ -110,6 +110,7 @@ test_params(void)
 		l = len;
 		len >>= 16;
 		h = len >> 16;
+		l &= 0xfffffffflu;
 		if (h != 0 || l != 2) {
 			fprintf(stderr, "Wrong number returned in param rows high %lu low %lu\n", h, l);
 			exit(1);
@@ -223,6 +224,7 @@ test_rows(void)
 		l = len;
 		len >>= 16;
 		h = len >> 16;
+		l &= 0xfffffffflu;
 		if (h != 0 || l != 2) {
 			fprintf(stderr, "Wrong number returned in rows high %lu(0x%lx) low %lu(0x%lx)\n", h, h, l, l);
 			exit(1);
diff --git a/src/tds/query.c b/src/tds/query.c
index 61c266d..3cd8c5f 100644
--- a/src/tds/query.c
+++ b/src/tds/query.c
@@ -46,7 +46,7 @@
 
 #include <assert.h>
 
-TDS_RCSID(var, "$Id: query.c,v 1.218 2008/01/20 14:23:59 freddy77 Exp $");
+TDS_RCSID(var, "$Id: query.c,v 1.219 2008/02/13 08:52:09 freddy77 Exp $");
 
 static void tds_put_params(TDSSOCKET * tds, TDSPARAMINFO * info, int flags);
 static void tds7_put_query_params(TDSSOCKET * tds, const char *query, int query_len);
@@ -577,7 +577,7 @@ tds_next_placeholder_ucs2le(const char *start, const char *end, int named)
 		case '?':
 			return p;
 		case '@':
-			if (named && !isalnum(prev))
+			if (named && !isalnum((unsigned char) prev))
 				return p;
 		default:
 			p += 2;
@@ -849,7 +849,7 @@ tds7_build_param_def_from_params(TDSSOCKET * tds, const char* query, size_t quer
 					continue;
 				/* find end of param name */
 				for (id_end = e + 2; id_end != query_end; id_end += 2)
-					if (!id_end[1] && (id_end[0] != '_' && id_end[1] != '#' && !isalnum(id_end[0])))
+					if (!id_end[1] && (id_end[0] != '_' && id_end[1] != '#' && !isalnum((unsigned char) id_end[0])))
 						break;
 				ids[i].p = e;
 				ids[i].len = id_end - e;

